import math
import sys
import random
import argparse

random.seed(''.join(sys.argv[1:]))

parser = argparse.ArgumentParser(description="Random generator")

parser.add_argument('seed', metavar='N')

parser.add_argument("--min-n", metavar="min_n", default=1, type=int)
parser.add_argument("--max-n", metavar="max_n", default=int(1e5), type=int)

parser.add_argument("--min-x", metavar="min_x", default=1, type=int)
parser.add_argument("--max-x", metavar="max_x", default=int(1e5), type=int)

parser.add_argument("--min-k", metavar="min_k", default=0, type=int)
parser.add_argument("--max-k", metavar="max_k", default=int(1e10), type=int)

parser.add_argument("--min-m", metavar="min_m", default=1, type=int)
parser.add_argument("--max-m", metavar="max_m", default=60, type=int)

parser.add_argument("--zeros", metavar="zeros", default=None, type=int)

args = parser.parse_args()

alphabet = 'abcdefghijklmnopqrstuvwxyz012345689 '

def create_title(m):
    book = random.choice(alphabet[:-1])
    last = book[0]
    i = 2
    while i < m:
        new_letter = random.choice(alphabet)
        if last == ' ' and new_letter == ' ': continue
        last = new_letter
        book += new_letter
        i += 1
    if m > 1:
        book += random.choice(alphabet[:-1])
    return book

n = random.randint(args.min_n, args.max_n)

random_xs = []
for i in range(n):
    random_xs.append(random.randint(args.min_x, args.max_x))
total = sum(random_xs)

xs = []
zeros = 0
max_value = random.randint(args.min_x, args.max_x)
for x in random_xs:
    y = int((x*max_value)//total)
    if y == 0:
        zeros += 1
    xs.append(y)

if args.zeros is not None:
    while zeros < args.zeros:
        i = random.randint(0, len(xs)-1)
        if xs[i] != 0:
            xs[i] = 0
            zeros += 1

k = random.randint(max(n-zeros,args.min_k), args.max_k)

ls = []
for x in xs:
    l = random.randint(int(math.sqrt(x)*2)+1, int(math.sqrt(x)*2)+1+x)
    ls.append(l)

random_ms = []
for l in ls:
    for _ in range(l):
        random_ms.append(random.randint(args.min_m, args.max_m))
total = sum(random_ms)

acc = 0
max_value = 1e5
ms = []
for m in random_ms:
    y = min(60, int((m*max_value)//total))
    if y == 0: y = 1
    if acc+y > 1e5:
        sys.exit(-1)
    acc += y
    ms.append(y)

print(n, k)

acc = 0
msi = 0
for x, l in zip(xs, ls):
    print(l)

    p = [i for i in range(0, l)]
    swaps = 0
    while swaps < x:
        a = random.randint(0, l-2)
        if p[a] < p[a+1]:
            p[a], p[a+1] = p[a+1], p[a]
            swaps += 1

    books = sorted([create_title(ms[msi+j]) for j in range(l)])
    acc += sum(len(book) for book in books)
    books = [books[p[i]] for i in range(l)]
    print('\n'.join(f'{len(book)} {book}' for book in books))

    msi += l
