#include <bits/stdc++.h>
using namespace std;

int N = 1e5+15;
vector<int> a (N);

typedef long long ll;

ll merge_sort (int l, int r) {
    if (r - l == 1) { return 0; }

    int mi = l + (r - l) / 2;

    ll swaps = 0;
    swaps += merge_sort(l, mi);
    swaps += merge_sort(mi, r);

    vector<int> aux (r - l);
    int i = l, j = mi;
    for (int k = 0; k < r - l; k++) {
        if (i < mi && j < r) {
            // Merging

            if (!(a[i] < a[j])) {
                swaps += mi - i;
            }

            if (a[i] < a[j]) {
                aux[k] = a[i++];
            } else {
                aux[k] = a[j++];
            }
        } else if (i < mi) {
            aux[k] = a[i++];
        } else {
            aux[k] = a[j++];
        }
    }

    copy(aux.begin(), aux.end(), a.begin()+l);
    return swaps;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    ll k;
    cin >> n >> k;

    vector<ll> inv (n);
    for (int i = 0; i < n; i++) {
        int l;
        cin >> l;

        vector<pair<string, int>> books (l);
        for (int j = 0; j < l; j++) {
            int m;
            cin >> m >> ws;

            string s;
            getline(cin, s);
            books[j] = make_pair(s, j);
        }

        sort(books.begin(), books.end());

        for (int i = 0; i < l; i++) {
            a[i] = books[i].second;
        }

        inv[i] = merge_sort(0, l);
    }

    vector<pair<ll, int>> inv_sorted (n);
    for (int i = 0; i < n; i++) {
        inv_sorted[i] = make_pair(inv[i], i);
    }
    sort(inv_sorted.begin(), inv_sorted.end());

    ll total = accumulate(inv.begin(), inv.end(), 0LL);
    vector<ll> allocation (n);

    if (total > 0) {
        int notzeros = 0;
        for (int i = 0; i < n; i++) if (inv[i] > 0) {
            allocation[i] = 1;
            notzeros++;
        }

        ll remaining = k;
        for (int i = 0; i < n; i++) {
            ll res;
            assert(!__builtin_smulll_overflow(k-notzeros, inv[i], &res));
            allocation[i] += res/total;
            remaining -= allocation[i];
        }

        for (int i = 0; i < n && remaining > 0; i++) {
            allocation[inv_sorted[i].second]++;
            remaining--;
        }

        assert(accumulate(allocation.begin(), allocation.end(), 0LL) == k);
    }

    for (int i = 0; i < n; i++) {
        if (inv[i] > 0) { assert(allocation[i] > 0); }
        cout << allocation[i] << "\n";
    }
}
