#include <bits/stdc++.h>
using namespace std;

int N = 1e5+15;

typedef long long ll;

vector<int> stree (4*N);

void add (int i, int d, int n) {
    stree[i += n] = d;
    for (i /= 2; i > 0; i /= 2) {
        stree[i] = stree[2*i] + stree[2*i+1];
    }
}

int query_exclusive (int i, int j, int n) {
    int left = 0, right = 0;
    for (i += n, j += n; i < j; i /= 2, j /= 2) {
        if (i % 2) left = left + stree[i++];
        if (j % 2) right = right + stree[--j];
    }
    return left + right;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    ll k;
    cin >> n >> k;

    vector<ll> inv (n);
    for (int i = 0; i < n; i++) {
        int l;
        cin >> l;

        vector<pair<string, int>> books (l);
        for (int j = 0; j < l; j++) {
            int m;
            cin >> m >> ws;

            string s;
            getline(cin, s);
            books[j] = make_pair(s, j);
        }

        sort(books.begin(), books.end());

        fill(stree.begin(), stree.begin()+4*l+5, 0);

        ll res = 0;
        for (int i = 0; i < l; i++) {
            int x = books[i].second;
            res += query_exclusive(x+1, l+1, l);
            add(x, +1, l);
        }
        inv[i] = res;
    }

    vector<pair<ll, int>> inv_sorted (n);
    for (int i = 0; i < n; i++) {
        inv_sorted[i] = make_pair(-inv[i], i);
    }
    sort(inv_sorted.begin(), inv_sorted.end());

    ll total = accumulate(inv.begin(), inv.end(), 0LL);
    vector<ll> allocation (n);

    if (total > 0) {
        int notzeros = 0;
        for (int i = 0; i < n; i++) if (inv[i] > 0) {
            allocation[i] = 1;
            notzeros++;
        }

        ll remaining = k;
        for (int i = 0; i < n; i++) {
            ll res;
            assert(!__builtin_smulll_overflow(k-notzeros, inv[i], &res));
            allocation[i] += res/total;
            remaining -= allocation[i];
        }

        for (int i = 0; i < n && remaining > 0; i++) {
            allocation[inv_sorted[i].second]++;
            remaining--;
        }

        assert(accumulate(allocation.begin(), allocation.end(), 0LL) == k);
    }

    for (int i = 0; i < n; i++) {
        if (inv[i] > 0) { assert(allocation[i] > 0); }
        cout << allocation[i] << "\n";
    }
}
