#include "testlib.h"

std::string upper(std::string sa) {
    for (size_t i = 0; i < sa.length(); i++)
        if ('a' <= sa[i] && sa[i] <= 'z')
            sa[i] = sa[i] - 'a' + 'A';
    return sa;
}

int main(int argc, char * argv[]) {
    registerTestlibCmd(argc, argv);

    std::string ja = upper(ans.readWord());
    std::string pa = upper(ouf.readWord());

    if (pa != "YES" && pa != "NO" && pa != "Y" && pa != "N")
        quitf(_pe, "YES or NO expected, but %s found", pa.c_str());

    if (ja != "YES" && ja != "NO" && ja != "Y" && ja != "N")
        quitf(_fail, "YES or NO expected in answer, but %s found", ja.c_str());

    if ((ja == "YES" || ja == "Y") != (pa == "YES" || pa == "Y"))
        quitf(_wa, "expected %s, found %s", ja.c_str(), pa.c_str());

    if (ja == "YES" || ja == "Y") {
        int ja = ans.readInt();
        int pa = ouf.readInt();

        if (ja != pa) {
            quitf(_wa, "expected k=%d, found k=%d", ja, pa);
        }

        int k = ja;
        std::set<std::set<int> > js;
        for (int i = 0; i < k; i++) {
            std::set<int> pp;
            for (int j = 0; j < 4; j++) {
                pp.insert(ans.readInt());
            }
            if (pp.size() != 4) {
                quitf(_fail, "expected 4 distinct numbers in answer at page %d, found %d", i, pp.size());
            }
            js.insert(pp);
        }

        if (js.size() != k) {
            quitf(_fail, "expected %d distinct entries in answer, found %d", k, js.size());
        }

        std::set<std::set<int> > ps;
        for (int i = 0; i < k; i++) {
            std::set<int> pp;
            for (int j = 0; j < 4; j++) {
                pp.insert(ouf.readInt());
            }
            if (pp.size() != 4) {
                quitf(_wa, "expected 4 distinct numbers at page %d, found %d", i, pp.size());
            }
            ps.insert(pp);
        }

        if (ps.size() != k) {
            quitf(_wa, "expected %d distinct entries, found %d", k, ps.size());
        }

        for (auto pp : ps) {
            if (!js.count(pp)) {
                quitf(_wa, "incorrect entry %d %d %d %d given", *(pp.begin()), *(++pp.begin()), *(++++pp.begin()), *(++++++pp.begin()));
            }
            js.erase(pp);
        }

        if (js.size()) {
            quitf(_wa, "missing %d entries", js.size());
        }
    }

    quitf(_ok, "answer is %s", ja.c_str());
}
