#include "testlib.h"
#include <iostream>

using namespace std;

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    int valid = 0;
    if (argc > 2) {
        valid = atoi(argv[2]);
    }

    int n, m;
    if (valid == 0) {
        n = rnd.next(1, int(1e4));
        m = rnd.next(1, int(1e4));
    } else if (valid == 1) {
        n = rnd.next(110*2, 135*2);
        m = rnd.next(150*2, 180*2);

        if (rnd.next(0, 1)) {
            swap(n, m);
        }
    } else {
        n = valid-1;
        m = valid-1;
    }

    cout << n << " " << m << "\n";

    int p;
    if (argc > 3) {
        p = atoi(argv[3]);
    } else {
        p = rnd.next(1, int(1e5));
    }

    array<int, 4> p0 = { 1, 2, 4*p-1, 4*p };
    shuffle(p0.begin(), p0.end());
    vector<array<int, 4>> output = { p0 };

    int l;
    if (argc > 4) {
        l = atoi(argv[4]);
    } else {
        l = rnd.next(0, p-1);
    }

    vector<bool> pages (p-1);
    fill(pages.begin(), pages.begin()+l, true);
    shuffle(pages.begin(), pages.end());

    for (int i = 0; i < p-1; i++) if (pages[i]) {
        int j = i+1;
        array<int, 4> pp = { 2*j+1, 2*j+2, 4*p-2*j-1, 4*p-2*j };
        shuffle(pp.begin(), pp.end());
        output.push_back(pp);
    }

    shuffle(output.begin(), output.end());

    cout << output.size() << "\n";
    for (auto out : output) {
        for (int i = 0; i < 4; i++) {
            if (i != 0) { cout << " "; }
            cout << out[i];
        }
        cout << "\n";
    }
}
