#include <sstream>
#include "testlib.h"

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int N = inf.readInt(1, 1e4, "N");
    inf.readSpace();
    int M = inf.readInt(1, 1e4, "M");
    inf.readEoln();
    int F = inf.readInt(1, 1e5, "F");
    inf.readEoln();

    std::set<int> allpp;
    std::set<std::set<int>> pages;

    int mx = 0;

    for (int i = 0; i < F; i++) {
        std::set<int> pp;
        for (int i = 0; i < 4; i++) {
            if (i != 0) { inf.readSpace(); }
            int f = inf.readInt(1, 4e5, "f");
            mx = std::max(mx, f);
            pp.insert(f);
            allpp.insert(f);
        }
        inf.readEoln();

        pages.insert(pp);

        if (pp.size() != 4) {
            quitf(_fail, "expected 4 distinct integers at page %i", i);
        }
    }

    if (allpp.size() != 4*F) {
        quitf(_fail, "expected all fi to be distinct");
    }

    if (pages.size() != F) {
        quitf(_fail, "expected all pages to be distinct");
    }

    auto first_page = *pages.begin();
    std::vector<int> p0 (first_page.begin(), first_page.end());

    if (p0[0] != 1) {
        quitf(_fail, "expected first page to be present");
    }
    if (p0[3] != mx) {
        quitf(_fail, "expected last page to be present in the same page as the first");
    }

    for (auto page : pages) {
        std::vector<int> f (page.begin(), page.end());

        int f0 = f[0]; int f1 = f[1]; int f2 = f[2]; int f3 = f[3];

        if (f0+1 != f1) {
            quitf(_fail, "expected f0 %d and f1 %d to be one after the other", f0, f1);
        }

        if (f2+1 != f3) {
            quitf(_fail, "expected f2 %d and f3 %d to be one after the other", f2, f3);
        }

        if (f0+f2 != mx) {
            quitf(_fail, "expected f0 %d and f2 %d to sum %d", f0, f2, mx);
        }
    }

    inf.readEof();
}
