#include "testlib.h"

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int N = inf.readInt(1, 1e6, "N");
    inf.readEoln();

    std::string S = inf.readString();

    if (S.size() != N) {
        quitf(_fail, "Line has length %d, but expected %d", S.size(), N);
    }
    
    if (!('a' <= S[0] && S[0] <= 'z') && !('A' <= S[0] && S[0] <= 'Z')) {
        quitf(_fail, "Line should start with [A-Za-z]");
    }

    for (int i = 0; i < N; i++) {
        if ('a' <= S[i] && S[i] <= 'z') { continue; }
        if ('A' <= S[i] && S[i] <= 'Z') { continue; }
        if ('0' <= S[i] && S[i] <= '9') { continue; }
        if (S[i] == ' ' || S[i] == ',' || S[i] == '.') { continue; }
        if (S[i] == '(' || S[i] == ')') { continue; }
        if (S[i] == '[' || S[i] == ']') { continue; }
        if (S[i] == '{' || S[i] == '}') { continue; }
        if (S[i] == '<' || S[i] == '>') { continue; }
        if (S[i] == '+' || S[i] == '-' || S[i] == '*' || S[i] == '/' || S[i] == '=') { continue; }
        quitf(_fail, "Line has character %c which is not expected", S[i]);
    }

    inf.readEof();
}
