#include "testlib.h"
#include <numeric>
#include <iostream>

using namespace std;

typedef pair<int, int> ii;

#define xx first
#define yy second

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    int n;
    if (argc > 2) {
        n = atoi(argv[2]);
    } else {
        n = rnd.next(1, int(1e3));
    }

    cout << n << "\n";

    while (n--) {
        int l;
        if (argc > 3) {
            l = atoi(argv[3]);
        } else {
            l = rnd.next(1, int(500));
        }

        cout << l << "\n";

        int t;
        do {
            t = rnd.next(1, int(1e5));
        } while (!(t - 1 <= l && l <= t*(t-1)/2));

        vector<int> p (t);
        for (int i = 1; i < t; i++) {
            p[i] = rnd.next(i);
        }

        vector<int> perm (t);
        for (int i = 0; i < t; i++)
            perm[i] = i;
        shuffle(perm.begin()+1, perm.end());
        set<set<int>> edges;

        for (int i = 1; i < t; i++) {
            set<int> edge;
            edge.insert(perm[p[i]]);
            edge.insert(perm[i]);
            edges.insert(edge);
        }

        while (edges.size() < l) {
            set<int> edge;
            edge.insert(rnd.next(0, t-1));
            edge.insert(rnd.next(0, t-1));
            if (edge.size() != 2) { continue; }
            edges.insert(edge);
        }

        set<ii> spts;
        while (spts.size() != 2*l) {
            spts.insert(ii(rnd.next(-1e5, 1e5), rnd.next(-1e5, 1e5)));
        }
        vector<ii> pts (spts.begin(), spts.end());

        for (auto e : edges) {
            auto u = pts[*(e.begin())];
            auto v = pts[*(++e.begin())];
            if (rnd.next(2)) { swap(u, v); }
            cout << u.xx << " " << u.yy << " " << v.xx << " " << v.yy << endl;
        }
    }
}
