#include "testlib.h"
#include <numeric>
#include <iostream>

using namespace std;

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    int n;
    if (argc > 2) {
        n = atoi(argv[2]);
    } else {
        n = rnd.next(1, int(1e3));
    }

    cout << n << "\n";

    vector<vector<int>> ops (n);
    vector<int> available (n);
    iota(available.begin(), available.end(), 0);

    int av = n;

    int mx;
    if (argc > 4) {
        mx = atoi(argv[4]);
    } else {
        mx = rnd.next(1, 100);
    }

    for (int i = 0; i < ((mx)*(n-1))/2; i++) {
        int j, k;
        do {
            j = rnd.next(0, av-1);
            k = rnd.next(0, av-1);
        } while (available[j] == available[k]);

        ops[available[j]].push_back(k+1);
        ops[available[k]].push_back(-(j+1));

        if (ops[available[j]].size() == mx) {
            swap(available[j], available[av-1]);
            av--;
        }
        if (ops[available[k]].size() == mx) {
            swap(available[k], available[av-1]);
            av--;
        }
    }

    for (int i = 0; i < n; i++) {
        cout << ops[i].size();
        for (int j = 0; j < ops[i].size(); j++) {
            cout << " " << ops[i][j];
        }
        cout << "\n";
    }

    int q;
    if (argc > 3) {
        q = atoi(argv[3]);
    } else {
        q = rnd.next(1, 100);
    }
    cout << q << "\n";

    while (q) {
        int u = rnd.next(0, n-1);
        int i = rnd.next(0, int(ops[u].size())-1);

        int v = rnd.next(0, n-1);
        int j = rnd.next(0, int(ops[v].size())-1);

        if (make_pair(u, i) == make_pair(v, j)) { continue; }

        q--;
        cout << u+1 << " " << i+1 << " " << v+1 << " " << j+1 << "\n";
    }
}
