#include <sstream>
#include <stack>
#include "testlib.h"

using namespace std;

vector<vector<int>> ops (1e3+15);
vector<int> pos(1e3+15);
vector<int> wait_recv(1e3+15, -1);
vector<int> wait_send(1e3+15, -1);

void process_ops(int u) {
    stack<int> S;
    S.push(u);

    while (!S.empty()) {
        int u = S.top(); S.pop();
        while (pos[u] < ops[u].size()) {
            int op = ops[u][pos[u]];
            pos[u]++;

            if (op > 0) {
                op--;
                if (wait_recv[op] == u) {
                    wait_recv[op] = -1;
                } else {
                    wait_send[u] = op;
                    S.push(u);
                    S.push(op);
                    break;
                }
            } else if (op < 0) {
                op = -op;
                op--;
                if (wait_send[op] == u) {
                    wait_send[op] = -1;
                } else {
                    wait_recv[u] = op;
                    S.push(u);
                    S.push(op);
                    break;
                }
            }
        }
    }
}

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int N = inf.readInt(1, 1e3, "N");
    inf.readEoln();

    vector<int> M (N+1);

    for (int i = 1; i <= N; i++) {
        int Mi = inf.readInt(1, 100, "Mi");
        M[i] = Mi;

        vector<int> op (Mi);
        for (int j = 0; j < Mi; j++) {
            inf.readSpace();
            op[j] = inf.readInt(-N, N, "mi");
        }
        ops[i-1] = op;
        inf.readEoln();
    }

    for (int u = 0; u < N; u++) { process_ops(u); }
    for (int u = 0; u < N; u++) if (pos[u] != ops[u].size()) {
        quitf(_fail, "Invalid sequence of events, found %d but expected %d for %d", pos[u], ops[u].size(), u);
    }

    int Q = inf.readInt(1, 100, "Q");
    inf.readEoln();
    while (Q--) {
        int i = inf.readInt(1, N, "i");
        inf.readSpace();
        int fi = inf.readInt(1, M[i], "fi");
        inf.readSpace();
        int j = inf.readInt(1, N, "j");
        inf.readSpace();
        int fj = inf.readInt(1, M[j], "fi");

        if (make_pair(i, fi) == make_pair(j, fj)) {
            quitf(_fail, "Same pair (%d, %d)", i, fi);
        }
        inf.readEoln();
    }
    inf.readEof();
}
