#include "testlib.h"

using namespace std;

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int N = inf.readInt(1, 100, "N");
    inf.readEoln();

    string pattern;
    inf.readLineTo(pattern);

    if (pattern.size() != N) {
        quitf(_fail, "pattern doesn't have size %d", N);
    }

    for (int i = 0; i < N; i++) {
        if ('0' <= pattern[i] && pattern[i] <= '9') { continue; }
        if ('A' <= pattern[i] && pattern[i] <= 'Z') { continue; }
        if ('a' <= pattern[i] && pattern[i] <= 'z') { continue; }
        if (' ' <= pattern[i] && pattern[i] <= ' ') { continue; }
        if ('%' <= pattern[i] && pattern[i] <= '%') { continue; }
        if ('_' <= pattern[i] && pattern[i] <= '_') { continue; }
        if (pattern[i] != '[') {
            quitf(_fail, "pattern has not expected character '%c'", pattern[i]);
        }
        if (i+1 < N && pattern[i+1] == ']') {
            quitf(_fail, "pattern has [] with no values inside");
        }

        if (i+1 < N && pattern[i+1] == '^') { i++; }

        while (++i < N && pattern[i] != ']') {
            if (i+1 < N && pattern[i+1] == '-') {
                if (!(i+2 < N)) { quitf(_fail, "pattern ends with -"); }
                if ('A' <= pattern[i] && pattern[i] <= 'Z') {
                    if (!('A' <= pattern[i+2] && pattern[i+2] <= 'Z')) {
                        quitf(_fail, "expected range %c- to end with an uppercase letter, not %c", pattern[i], pattern[i+2]);
                    }
                } else if ('a' <= pattern[i] && pattern[i] <= 'z') {
                    if (!('a' <= pattern[i+2] && pattern[i+2] <= 'z')) {
                        quitf(_fail, "expected range %c- to end with a lowercase letter, not %c", pattern[i], pattern[i+2]);
                    }
                } else if ('0' <= pattern[i] && pattern[i] <= '9') {
                    if (!('0' <= pattern[i+2] && pattern[i+2] <= '9')) {
                        quitf(_fail, "expected range %c- to end with a number, not %c", pattern[i], pattern[i+2]);
                    }
                } else if (' ' <= pattern[i] && pattern[i] <= ' ') {
                    if (!(' ' <= pattern[i+2] && pattern[i+2] <= ' ')) {
                        quitf(_fail, "expected range %c- to end with a space, not %c", pattern[i], pattern[i+2]);
                    }
                } else {
                    quitf(_fail, "unexpected range %c-%c", pattern[i], pattern[i+2]);
                }
                i += 2;
                continue;
            }
            if ('0' <= pattern[i] && pattern[i] <= '9') { continue; }
            if ('A' <= pattern[i] && pattern[i] <= 'Z') { continue; }
            if ('a' <= pattern[i] && pattern[i] <= 'z') { continue; }
            if (' ' <= pattern[i] && pattern[i] <= ' ') { continue; }
            quitf(_fail, "pattern has not expected character '%c'", pattern[i]);
        }

        if (!(i < N)) {
            quitf(_fail, "pattern ends without ]");
        }
    }

    int Q = inf.readInt(1, 1000, "Q");
    inf.readEoln();
    for (int i = 0; i < Q; i++) {
        int M = inf.readInt(1, 100, "M");
        inf.readSpace();
        string text;
        inf.readLineTo(text, format("[A-Za-z0-9\\ ]{%d}", M), "text");
    }

    inf.readEof();
}
