#include "testlib.h"
#include <numeric>
#include <cassert>
#include <iostream>

using namespace std;

typedef long long ll;

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    int n;
    if (argc > 2) {
        n = atoi(argv[2]);
    } else {
        n = rnd.next(1, int(1e6));
    }

    cout << n << "\n";

    ll sum = 0;
    vector<int> random_ms (n);
    for (int i = 0; i < n; i++) {
        random_ms[i] = rnd.next(4, int(1e8));
        sum += random_ms[i];
    }

    ll max_value;
    if (argc > 5) {
        max_value = atoll(argv[5]);
    } else {
        max_value = rnd.next(1, int(1e8-4));
    }

    int all_ms = -1;
    if (argc > 6) {
        all_ms = atoi(argv[6]);
    }

    vector<int> ms (n);
    for (int i = 0; i < n; i++) {
        if (all_ms == -1) {
            ms[i] = ((random_ms[i]*max_value)/sum) + 4;
        } else {
            ms[i] = all_ms;
        }

        assert(4 <= ms[i] && ms[i] <= 1e8);
    }

    int diff = -1;
    if (argc > 4) {
        diff = atoi(argv[4]);
    }

    ll p = 0;
    if (argc > 7) {
        p = atoll(argv[7]);
    }

    for (int i = 0; i < n; i++) {
        int m = ms[i];
        if (i != n-1) {
            if (diff == -1) {
                p += m + rnd.next(0LL, 10000LL);
            } else {
                p += m + diff;
            }
        } else {
            p = 0;
        }

        if (p > 1e10) { p = 1e10; }
        assert(p <= 1e10);

        cout << m << " " << p << "\n";
    }

    int t = -1;
    if (argc > 3) {
        t = atoi(argv[3]);
    }

    if (t == -1) {
        t = rnd.next(1, int(1e6));
    }

    cout << t << "\n";
}
